/*
 * ウチの場合は
 *     DashUchino.js
 *     http://www2.atwiki.jp/macstar/pages/22.html
 */

var uchinoUri = "http://www.mainichi-msn.co.jp/kurashi/shumi/uchi/";
var comicUri = "Images/dummy.png";
var widgetUri = "http://www2.atwiki.jp/macstar/pages/22.html";
var timeStamp = 0;
var stretcher;
var doneButton, infoButton;

// Initialize widget
function init() {
	if (window.widget)
		widget.onshow = onShow;

	// 伸縮機能（サンプルウィジェット Stretcher より）+445pixels
	stretcher = new Stretcher(document.getElementById("front"), 445, 300, stretched);

	// 環境設定ボタンと完了ボタン
	infoButton = new AppleInfoButton(document.getElementById("infoButton"),
		document.getElementById("front"), "white", "white", showPrefs);
	doneButton = new AppleGlassButton(document.getElementById("doneButton"),
		"Done", hidePrefs);

	// 伸縮ボタンのフォーカス演出用マウスイベント
	document.getElementById("comic").addEventListener("mouseover", focusButton, true);
	document.getElementById("comic").addEventListener("mouseout", unfocusButton, true);
	document.getElementById("stretchButton").addEventListener("mouseover", focusButton, true);
	document.getElementById("stretchButton").addEventListener("mouseout", unfocusButton, true);

	// WWW ブラウザで開いたときの読みこみ処理
	if (!window.widget)
		getHTML();
}

function onShow() {
	// 最終取得時刻より 10 分以上経過していたらリロード
	if (timeStamp + 10*60*1000 <= (new Date).getTime())
		getHTML();
}

// コミックページの HTML をダウンロード
function getHTML() {
	var httpReq;
	var dd;
	var lastGetTime;
	var textDoc;
	var newComicUri;

	// If-Modified-Since の値（最終取得時刻）を用意
	dd = new Date();
	dd.setTime(timeStamp);
	lastGetTime = dd.toUTCString();

	// 読みこみ（同期）
	httpReq = new XMLHttpRequest();
	httpReq.open("GET", uchinoUri, false);
	httpReq.setRequestHeader("If-Modified-Since", lastGetTime);
	httpReq.send(null);

	// ダウンロード成功時
	if (httpReq.status == 200) {
		// 最終取得時刻を更新
		timeStamp = (new Date).getTime();
		// コミック画像の URI を探す
		textDoc = httpReq.responseText;
		if (textDoc.match(/src=\"\/kurashi\/shumi\/uchi\/(news\/images\/\w+\.gif)\"/)) {
			newComicUri = uchinoUri + RegExp.$1;
			// 新しい画像が見つかったら表示する
			if (comicUri != newComicUri) {
				comicUri = newComicUri;
				document.getElementById("comic").setAttribute("src", comicUri);
			}
		}
	} else {
		alert("XMLHttpRequest error. status:" + httpReq.status);
	}

	// デバッグ用
	document.getElementById("uri").innerText = comicUri;
	document.getElementById("status").innerText = httpReq.status;
	document.getElementById("timeStamp").innerText = timeStamp;
//	if (window.widget) alert("getHTML:" + timeStamp);
}

// 伸縮ボタンの書き換え（stretcher.stretch() 実行時に呼び出される）
function stretched() {
	document.getElementById("stretchButton").src = 
		(stretcher.isStretched())? "Images/shrink.png" : "Images/stretch.png";
}

// 伸縮ボタンのフォーカス演出
function focusButton() {
	document.getElementById("stretchButton").style.opacity = 1.0;
}

function unfocusButton() {
	document.getElementById("stretchButton").style.opacity = 0.4;
}

// 環境設定画面
function showPrefs() {
	if (window.widget)
		widget.prepareForTransition("ToBack");

	document.getElementById("front").style.display = "none";
	document.getElementById("back").style.display = "block";
	
	if (window.widget)
		setTimeout ("widget.performTransition();", 0);  
}

function hidePrefs() {
	if (window.widget)
		widget.prepareForTransition("ToFront");

	document.getElementById("front").style.display = "block";
	document.getElementById("back").style.display = "none";
	// リロードを試みる
	getHTML();

	if (window.widget)
		setTimeout ("widget.performTransition();", 0);
}

// URI を開く
function openWWW(uri) {
	if (window.widget)
		widget.openURL(uri);
	else
		window.location.href = uri;
}
